c     Input
      real*16 mv(3), theta12, theta13, theta23, CPphase, ReMUX(3),
     .        RelambdaX(3), ImMUX(3), ImlambdaX(3), ReAv(3),
     .        ReAX(3), ReBMUX(3), msx2(3), msn2(3), ImAv(3),
     .        ImAX(3), ImBMUX(3)

      complex*32   thetaCI(3), MUX(3), lambdaX(3), Av(3), BMUX(3), AX(3)

c     variables from SLHA_read_leshouches
      real*16 upmnsinval(1:20),neuinval(1:40),sneuinval(1:40),
     .        imsneuinval(1:40), imneuinval(1:40)
     
c     Neutrino,sneutrino mass Output
      real*16    msv18(18), UsV(18,18), msv18Matrix(18,18), mv9(9)
      complex*32 UV(9,9), mv9Matrix(9,9), Yv(3,3), UPMNS(3,3)
      double precision mv9R(9),UVR(9,9)

c     Counterterms Output
      complex*32 dMW2fin,dMZ2fin,dMHpm2fin,dvfin,dthdfin,dthufin,
     .        dthsfin,dtadfin,dtasfin, dHHMassfin(5,5)

c     Constant
      complex*32 zi, z0
      parameter (zi = CMPLX(0.0,1.0), z0 = CMPLX(0.0,0.0))
      
      real*16 two, sqrt2
      parameter (two = 2., sqrt2 = sqrt(two))
      
      double precision, parameter :: I3Matrix(3,3) = reshape(
     .                            (/ 1.0, 0.0, 0.0,
     .                               0.0, 1.0, 0.0,
     .                               0.0, 0.0, 1.0 /), shape(I3Matrix))
     
c     Other
      real*16 ZH6(6,6)
      complex*32 HHMassCTfin(5,5)
      integer cc0,cc1,cc2,cc00,cc11,cc12,cc22

c     Functions
      REALTYPE A0fin,B0fin,B00fin,B1fin
      COMPLEXTYPE B0Cfin,B00Cfin,B1Cfin
      double precision myA0
      double complex myB0i,myB0Ci
      

      COMMON /neuin/ mv, theta12, theta13, theta23,CPphase,
     .        MUX, lambdaX, ReMUX, RelambdaX, ImMUX, ImlambdaX, thetaCI
      COMMON /neusoftbreak/ ReAv, ReAX, ReBMUX, msx2, msn2,
     .        ImAv, ImAX, ImBMUX, Av, BMUX, AX
      COMMON /SLHA_leshouches_ISS_NMSSM/ upmnsinval,neuinval,
     .        sneuinval,imsneuinval, imneuinval
      COMMON /issmasses/ mv9,msv18, Yv, Mv9Matrix
      COMMON /neumassesout/ mv9R,UVR
      COMMON /issrot/ UV, UsV, UPMNS
      common /higgsmass/ ZH6,HHMassCTfin
      common /counterterm/
     .        dMW2fin,dMZ2fin,dMHpm2fin,dvfin,dthdfin,dthufin,dthsfin,
     .        dtadfin,dtasfin,dHHMassfin
      common /C0iID/ cc0,cc1,cc2,cc00,cc11,cc12,cc22



c ND add
      integer I2G3,I2G4,I3G3,I3G4,I5G3,I5G4,I6G3,I6G4,I9G3,I9G4,I183,I184,
     .        gen3
      REALTYPE pi,finite 
      parameter (pi = 2_dp*Asin(1_dp), finite=0_dp)
    

        complex*32 CSemSvVWpA(6,18),CSemSvVWpVZ(6,18),CSvSepAVWm(18,6),
     -  CSvSepVWmVZ(18,6),CSvSvVWpVWm(18,18),CSvSvVZVZ(18,18),
     -  CLFepF12Sv(3,2,18),CRFepF12Sv(3,2,18),CLF11FvSv(5,9,18),
     -  CRF11FvSv(5,9,18),CLF12FemSv(2,3,18),CRF12FemSv(2,3,18),
     -  ChSvSv(6,18,18),CHmSvSep(2,18,6),CSemSvHp(6,18,2),
     -  CSemSvVWp(6,18),CSvSvVZ(18,18),CSvSepVWm(18,6),
     -  ChhSvSv(6,6,18,18),ChHmSvSep(6,2,18,6),ChSemSvHp(6,6,18,2),
     -  CHmSvSvHp(2,18,18,2),CSdmSvSvSdp(6,18,18,6),
     -  CSdmSvSepSum(6,18,6,6),CSemSupSvSdp(6,6,18,6),
     -  CSemSvSvSep(6,18,18,6),CSupSvSvSum(6,18,18,6),
     -  CSvSvSvSv(18,18,18,18),CHmSemHpSep(2,6,2,6)

        complex*32 CLFvF12Sep(9,2,6),CRFvF12Sep(9,2,6),CLFvFemHp(9,3,2),
     -  CRFvFemHp(9,3,2),CLFvFvh(9,9,6),CRFvFvh(9,9,6),
     -  CLFepFvHm(3,9,2),CRFepFvHm(3,9,2),CLF12FvSem(2,9,6),
     -  CRF12FvSem(2,9,6),CLFvFemVWp(9,3),CRFvFemVWp(9,3),
     -  CLFvFvVZ(9,9),CRFvFvVZ(9,9),CLFepFvVWm(3,9),
     -  CRFepFvVWm(3,9)

        Common/ISSNe/ CSemSvVWpA,CSemSvVWpVZ,CSvSepAVWm,CSvSepVWmVZ,
     -  CSvSvVWpVWm,CSvSvVZVZ,CLFepF12Sv,CRFepF12Sv,CLF11FvSv,
     -  CRF11FvSv,CLF12FemSv,CRF12FemSv,ChSvSv,CHmSvSep,CSemSvHp,
     -  CSemSvVWp,CSvSvVZ,CSvSepVWm,ChhSvSv,ChHmSvSep,ChSemSvHp,
     -  CHmSvSvHp,CSdmSvSvSdp,CSdmSvSepSum,CSemSupSvSdp,
     -  CSemSvSvSep,CSupSvSvSum,CSvSvSvSv,CHmSemHpSep

        Common/ISSNe/ CLFvF12Sep,CRFvF12Sep,CLFvFemHp,CRFvFemHp,CLFvFvh,
     -  CRFvFvh,CLFepFvHm,CRFepFvHm,CLF12FvSem,CRF12FvSem,
     -  CLFvFemVWp,CRFvFemVWp,CLFvFvVZ,CRFvFvVZ,CLFepFvVWm,
     -  CRFepFvVWm

      double precision para_S,para_T,para_U,brmuega,brtauega,brtaumuga
      common/lowen_observables/para_S,para_T,para_U,brmuega,brtauega,
     -                 brtaumuga
       complex*32 mat1(3,3),mat2(3,3),mat3(3,3),mat4(3,3),mat5(3,3),mat6(3,3)
     &          ,mat7(3,3),mat8(3,3),mat9(3,3),mat10(3,3),mat11(3,3),
     &          mat12(3,3),mat13(3,3),mat14(3,3),mat15(3,3),mat16(3,3), 
     &          mat17(3,3),Yvc(3,3),diaglambdaXC(3,3),diagMUXC(3,3),Tv(3,3)
     &          ,Tvc(3,3),TX(3,3),TXC(3,3),diagBMUXC(3,3),diagMUX(3,3), 
     &           diaglambdaX(3,3), diagAv(3,3),diagBMUX(3,3), diagAX(3,3)
       double complex mue,muec,lam,lamc,kappa,kappaC
       common/matrixcomo/ mat1,mat2,mat3,mat4,mat5,mat6
     &          ,mat7,mat8,mat9,mat10,mat11,
     &          mat12,mat13,mat14,mat15,mat16, 
     &          mat17,Yvc,diaglambdaXC,diagMUXC,mue,muec,
     &          lam,lamc,kappa,kappaC,Tv
     &          ,Tvc,TX,TXC,diagBMUXC,diagMUX, diaglambdaX, diagAv,
     .           diagBMUX, diagAX

       double complex expeta,expetas,expetal,expetak
       common/complexphases/expeta,expetas,expetal,expetak


